<!DOCTYPE html>
<html lang="EN">

{% if site is not defined %}
{% set site = "L39" %}
{% endif %}
{% set filter = dict({"siteName": ["like",site]}) %}
{% set ipf = client() %}

<head>
  <meta charset="utf-8">
  <title>IPF Report</title>
</head>

<body>
  <!-- First page content -->
  <br><br>
  <div class="logo">
    <img alt="IP Fabric logo" src="{{ logo_url }}"/>
  </div>
  <div class="main-title">
    <h1>LLD Report</h1>
  </div>

  <!-- Second page content -->
  <div class="container">
    <div class="section-1">
      <div class="icon-container">
        <div class="section-title"> IP Fabric Overview - Site `{{ site }}`</div>
      </div>
      <div>
        The IP Fabric data report presents a comprehensive network infrastructure analysis, providing detailed insights
        into
        various sections such as network inventory, interfaces, addressing, switching, routing, and wireless
        technologies.
      </div>
    </div>
    <div class="main-title-container">
        <div class="numbers">1</div>
        <h2 class="main-titles">Instance Information</h2>
    </div>
    <table>
      <tr>
        <th>IP Fabric url</th>
        <td>{{ ipf.hostname }}</td>
      </tr>
      <tr>
        <th>IP Fabric Version</th>
        <td>{{ ipf.os_version }}</td>
      </tr>
      <tr>
        <th>Snapshot Name</th>
        <td>{{ ipf.snapshot.name }}</td>
      </tr>
      <tr>
        <th>Snapshot ID</th>
        <td>{{ ipf.snapshot.snapshot_id }}</td>
      </tr>
    </table>
    <div class="main-title-container">
      <div class="numbers">2</div>
      <h2 class="main-titles">Network data summary</h2>
    </div>
    <table>
      <thead>
        <tr>
          <th colspan="3", style="text-align: center;">Device Inventory</th>
        </tr>
        <tr>
          <th>Hostname</th>
          <th>FQDN</th>
          <th>Domain</th>
        </tr>
      </thead>
      <tbody>
        {% for device in ipf.inventory.devices.all(filters=filter) %}
          <tr>
            <td>{{ device.hostname }}</td>
            <td>{{ device.fqdn or '-' }}</td>
            <td>{{ device.domain or '-' }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
    <br>
    <table>
      <tr>
        <th>Network hosts/IP endpoints</th>
        <td>{{ ipf.inventory.hosts.count(filters=filter) }}</td>
      </tr>
    </table>
    <div class="main-title-container">
      <div class="numbers">3</div>
      <h2 class="main-titles">Interfaces overview</h2>
    </div>
    <div class="section-3">
      The Interfaces overview section provides insights into the network interfaces of the infrastructure. It reports on
      the total number of active interfaces, the number of edge interfaces, and the number of switchport interfaces. It
      also includes information on channel interfaces and the number of IPv4 and IPv6 tunnel interfaces. Finally, it
      provides details on the number of IPsec tunnels and gateways.
    </div>
    <div class="div-spacing">
      <table>
        <tr>
          <th>Network interfaces</th>
        </tr>
        <tr>
          <th>Interfaces Count</th>
          <td>{{ ipf.inventory.interfaces.count(filters=filter) }}</td>
        </tr>
        <tr>
          <th>Switchport interfaces</th>
          <td>{{ ipf.technology.interfaces.switchport.count(filters=filter) }}</td>
        </tr>
        <tr>
          <th>Channel interfaces</th>
          <td>{{ ipf.technology.port_channels.member_status_table.count(filters=filter) }}</td>
        </tr>
        <tr>
          <th>IPv4 Tunnel interfaces</th>
          <td>{{ ipf.technology.interfaces.tunnels_ipv4.count(filters=filter) }}</td>
        </tr>
        <tr>
          <th>IPv6 Tunnel interfaces</th>
          <td>{{ ipf.technology.interfaces.tunnels_ipv6.count(filters=filter) }}</td>
        </tr>
        <tr>
          <th>IPsec Gateways</th>
          <td>{{ ipf.technology.security.ipsec_gateways.count(filters=filter) }}</td>
        </tr>
        <tr>
          <th>IPsec tunnels</th>
          <td>{{ ipf.technology.security.ipsec_tunnels.count(filters=filter) }}</td>
        </tr>
      </table>
    </div>
    <br>
    <div class="div-spacing">
      {% set graph_data = graphs.bar_chart(graphs.count_values(ipf.inventory.interfaces.all(), ['l1', 'l2']), 'l1', ['up', 'down'], x_label="Layer 1/2 Status", y_label="count", title="Interface Status") %}
      {{ graph_data }}
    </div>
    <br>
    <div class="div-spacing">
      <table>
        <thead>
          <tr>
            <th colspan="5", style="text-align: center;">Half Duplex interfaces</th>
          </tr>
          <tr>
            <th>Hostname</th>
            <th>Interface</th>
            <th>Speed</th>
            <th>Duplex</th>
            <th>Description</th>
          </tr>
        </thead>
        <tbody>
          {% set duplex_filter = filter.copy() %}
          {% set _ = duplex_filter.update({'duplex': ['color', 'eq', '20']}) %}
          {% for interface in ipf.inventory.interfaces.fetch(filters=duplex_filter, columns=["hostname", "intName", "speed", "duplex", "dscr"], reports="/inventory/interfaces") %}
            <tr>
              <td>{{ interface.hostname }}</td>
              <td>{{ interface.intName or '-' }}</td>
              <td>{{ interface.speed or '-' }}</td>
              <td>{{ interface.duplex.data or '-' }}</td>
              <td>{{ interface.dscr.data or '-' }}</td>
            </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
    <div class="main-title-container">
      <div class="numbers">4</div>
      <h2 class="main-titles">Addressing overview</h2>
    </div>
    <div class="section-4">
      The Addressing Overview section provides a detailed summary of the network addressing aspects based on two
      snapshots. It presents statistical data on managed networks, IPv4 and IPv6 interfaces, Address Resolution Protocol
      (ARP) tables, and Virtual Route Forwarding (VRF) instances. The first number indicates the current value, and the
      second number represents the change between two snapshots. This section provides valuable insights into the growth
      and changes in network addressing over time.
    </div class="div-spacing">
    <table>
      <tr>
        <th>Managed networks</th>
        <td>{{ ipf.technology.managed_networks.networks.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>IPv4 interfaces</th>
        <td>{{ ipf.technology.addressing.managed_ip_ipv4.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>IPv6 interfaces</th>
        <td>{{ ipf.technology.addressing.managed_ip_ipv6.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>ARP entries</th>
        <td>{{ ipf.technology.addressing.arp_table.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>MAC entries</th>
        <td>{{ ipf.technology.addressing.mac_table.count(filters=filter) }}</td>
      </tr>
    </table>
    <br>
    <div class="div-spacing">
      <table>
        <thead>
          <tr>
            <th colspan="8", style="text-align: center;">List of Managed IP addresses</th>
          </tr>
          <tr>
            <th>Hostname</th>
            <th>Interface</th>
            <th>L1 State</th>
            <th>L2 State</th>
            <th>IP</th>
            <th>Network</th>
            <th>Type</th>
            <th>VRF</th>
          </tr>
        </thead>
        <tbody>
          {% for interface in ipf.technology.addressing.managed_ip_ipv4.all(filters=filter) %}
            <tr>
              <td>{{ interface.hostname }}</td>
              <td>{{ interface.intName or '-' }}</td>
              <td>{{ interface.stateL1 or '-' }}</td>
              <td>{{ interface.stateL2 or '-' }}</td>
              <td>{{ interface.ip or '-' }}</td>
              <td>{{ interface.net or '-' }}</td>
              <td>{{ interface.type or '-' }}</td>
              <td>{{ interface.vrf or '-' }}</td>
            </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
    <div class="main-title-container">
      <div class="numbers">5</div>
      <h2 class="main-titles">Switching overview</h2>
    </div>
    <div class="section-5">
      The Switching overview section provides key statistics on the status of network switching components. These
      include
      data on MAC addresses, VLANs, and Spanning Tree Protocol (STP) instances, bridges, virtual ports, and neighbors.
    </div>
    <table>
      <tr>
        <th>MAC entries</th>
        <td>{{ ipf.technology.addressing.mac_table.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>VLANs</th>
        <td>{{ ipf.technology.vlans.site_summary.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>STP VLANs</th>
        <td>{{ ipf.technology.stp.vlans.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>STP Bridges</th>
        <td>{{ ipf.technology.stp.bridges.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>STP Virtual Ports</th>
        <td>{{ ipf.technology.stp.ports.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>STP Instances</th>
        <td>{{ ipf.technology.stp.instances.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>STP Neighbors</th>
        <td>{{ ipf.technology.stp.neighbors.count(filters=filter) }}</td>
      </tr>
    </table>
    <div class="main-title-container">
      <div class="numbers">6</div>
      <h2 class="main-titles">Routing overview</h2>
    </div>
    <div class="section-6">
      The Routing overview section provides statistical data on the number of IPv4 and IPv6 routes, as well as the
      number
      of routes per protocol, including Connected, Static, BGP, OSPF, IS-IS, EIGRP, and RIP. Additionally, the report
      shows changes between two snapshots, including the number of added or removed routes for each protocol. This
      information allows network administrators to quickly understand the changes that have occurred in their network's
      routing tables.
    </div>
    <table>
      <tr>
        <th>IPv4 routes</th>
        <td>{{ ipf.technology.routing.routes_ipv4.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>IPv6 routes</th>
        <td>{{ ipf.technology.routing.routes_ipv6.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>Multicast routes</th>
        <td>{{ ipf.technology.multicast.mroute_table.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>Attached routes</th>
        {% set tmp_filter = filter.copy() %}
        {% set _ = tmp_filter.update({'protocol': ["eq", "A"]}) %}
        <td>{{ ipf.technology.routing.routes_ipv4.count(filters=tmp_filter) }}</td>
      </tr>
      <tr>
        <th>BGP routes</th>
        {% set _ = tmp_filter.update({'protocol': ["eq", "B"]}) %}
        <td>{{ ipf.technology.routing.routes_ipv4.count(filters=tmp_filter) }}</td>
      </tr>
      <tr>
        <th>Connected routes</th>
        {% set _ = tmp_filter.update({'protocol': ["eq", "C"]}) %}
        <td>{{ ipf.technology.routing.routes_ipv4.count(filters=tmp_filter) }}</td>

      </tr>
      <tr>
        <th>Default Gateway</th>
        {% set _ = tmp_filter.update({'protocol': ["eq", "DGW"]}) %}
        <td>{{ ipf.technology.routing.routes_ipv4.count(filters=tmp_filter) }}</td>

      </tr>
      <tr>
        <th>EIGRP routes</th>
        {% set _ = tmp_filter.update({'protocol': ["eq", "D"]}) %}
        <td>{{ ipf.technology.routing.routes_ipv4.count(filters=tmp_filter) }}</td>

      </tr>
      <tr>
        <th>ISIS routes</th>
        {% set _ = tmp_filter.update({'protocol': ["eq", "IS-IS"]}) %}
        <td>{{ ipf.technology.routing.routes_ipv4.count(filters=tmp_filter) }}</td>

      </tr>
      <tr>
        <th>OSPF routes</th>
        {% set _ = tmp_filter.update({'protocol': ["eq", "O"]}) %}
        <td>{{ ipf.technology.routing.routes_ipv4.count(filters=tmp_filter) }}</td>

      </tr>
      <tr>
        <th>RIP routes</th>
        {% set _ = tmp_filter.update({'protocol': ["eq", "R"]}) %}
        <td>{{ ipf.technology.routing.routes_ipv4.count(filters=tmp_filter) }}</td>
      </tr>
      <tr>
        <th>Static routes</th>
        {% set _ = tmp_filter.update({'protocol': ["eq", "S"]}) %}
        <td>{{ ipf.technology.routing.routes_ipv4.count(filters=tmp_filter) }}</td>
      </tr>
    </table>
    <div class="main-title-container">
      <div class="numbers">7</div>
      <h2 class="main-titles">Wireless overview</h2>
    </div>
    <div class="section-7">
      The Wireless overview section provides statistical data about the wireless infrastructure within the network,
      including controllers, access points, radios, and clients.
      This data can be used to gain insights into the overall performance and utilization of the wireless network
      infrastructure.
    </div>
    <table>
      <tr>
        <th>Wireless controllers</th>
        <td>{{ ipf.technology.wireless.controllers.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>Wireless access points</th>
        <td>{{ ipf.technology.wireless.access_points.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>Wireless radios and SSID summary</th>
        <td>{{ ipf.technology.wireless.radios_detail.count(filters=filter) }}</td>
      </tr>
      <tr>
        <th>Wireless clients</th>
        <td>{{ ipf.technology.wireless.clients.count(filters=filter) }}</td>
      </tr>
    </table>
    <div class="main-title-container">
      <div class="numbers">8</div>
      <h1 class="main-titles" style="page-break-before: always;">Site Topology</h1>
    </div>
    <div class="section-8">
      Accurate network documentation is crucial for effective knowledge sharing among team members,
      as well as for internal communication and audit purposes. In this section, you'll find topology
      information for selected sites, along with SVG images that provide graphical representations of
      the network.
    </div>
      {% set topology = site_topology(ipf, site) %}
      <h4>Topology diagram</h5>
      <div class="path_svg">
        <img src="{{ topology.svg_data }}" alt="Topology diagram" alt="Path result" style="width: 100%;">
      </div>
  </div>
</body>

</html>
